# 酷我音乐<!-- {docsify-ignore} -->

## 获取音乐播放地址

请求地址：`/v1/kuwo/song`

请求示例：`http://iecoxe.top:5000/v1/kuwo/song?rid=156483846`

| 参数 | 是否必须 | 接口说明 | 默认值    |
| ---- | -------- | -------- | --------- |
| rid  | √        | 音乐 ID  | 156483846 |
| br   | ×        | 音质     | 320       |

说明：`br    24 48 96 128 192 320 1000`   `注: br=1000 获取 ape 无损格式`



flac音质获取： 此服务单独部署再5500端口，此接口不在 wp_MusicAPI 接口中

请求地址：`/`

flac音质请求示例：`http://iecoxe.top:5500?rid=156483846&br=2000`

| 参数 | 是否必须 | 接口说明 | 默认值    |
| ---- | -------- | -------- | --------- |
| rid  | √        | 音乐 ID  | 156483846 |
| br   | ×        | 音质     | 无        |





## 获取音乐详情

请求地址：`/v1/kuwo/songInfo`

请求示例：`http://iecoxe.top:5000/v1/kuwo/songInfo?rid=156483846`

| 参数 | 是否必须 | 接口说明 | 默认值    |
| ---- | -------- | -------- | --------- |
| rid  | √        | 音乐 ID  | 156483846 |





## 获取音乐歌词

请求地址：`/v1/kuwo/lyric`

请求示例：`http://iecoxe.top:5000/v1/kuwo/lyric?rid=156483846`

| 参数 | 是否必须 | 接口说明      | 默认值    |
| ---- | -------- | ------------- | --------- |
| rid  | √        | 音乐 ID       | 156483846 |
| from | ×        | `pc` 或 `web` | `pc`      |



## 搜索

请求地址：`/v1/kuwo/search`

请求示例：`http://iecoxe.top:5000/v1/kuwo/search?key=周杰伦`

| 参数   | 是否必须 | 接口说明       | 默认值   |
| ------ | -------- | -------------- | -------- |
| key    | √        | 关键字         | 默认为空 |
| limit  | ×        | 搜索结果的数量 | 30       |
| offset | ×        | 数据的偏移量   | 1        |
| from   | ×        | `pc` 或 `web`  | web      |

说明：`offset相当于页数，1，2，3，…  不需要 乘以 limit`

注意：from=pc，理论上讲更加稳定点，from=web，比较容易请求失败



## 热门搜索

请求地址：`/v1/kuwo/hotSearch`

请求示例：`http://iecoxe.top:5000/v1/kuwo/hotSearch`

| 参数 | 是否必须 | 接口说明             | 默认值 |
| ---- | -------- | -------------------- | ------ |
| from | ×        | from填 `pc` 或 `web` | `pc`   |

说明：`pc`返回的数据量比较详细



## 搜索建议

请求地址：`/v1/kuwo/suggestSearch`

请求示例：`http://iecoxe.top:5000/v1/kuwo/suggestSearch?key=周`

| 参数 | 是否必须 | 接口说明 | 默认值   |
| ---- | -------- | -------- | -------- |
| key  | √        | 关键字   | 默认为空 |





## 获取评论

请求地址：`/v1/kuwo/comment`

请求示例：`http://iecoxe.top:5000/v1/kuwo/comment?id=156483846&type=1&limit=50`

| 参数   | 是否必须 | 接口说明                     | 默认值 |
| ------ | -------- | ---------------------------- | ------ |
| id     | √        | rid 或 DC_TARGETID           | 无     |
| offset | ×        | 偏移量                       | 1      |
| limit  | ×        | 返回数据量                   | 30     |
| type   | ×        | 0：获取最新评论，1：获取热评 | 0      |









## 获取排行榜

请求地址：`/v1/kuwo/top`

请求示例：`http://iecoxe.top:5000/v1/kuwo/top?topId=16`

| 参数   | 是否必须 | 接口说明       | 默认值 |
| ------ | -------- | -------------- | ------ |
| topId  | √        | 排行榜 ID      | 16     |
| limit  | ×        | 返回歌曲的数量 | 30     |
| offset | ×        | 偏移的页数     | 1      |
| from   | ×        | `pc` 或 `web`  | web    |

注意：from=pc，理论上讲更加稳定点，from=web，比较容易请求失败



## 获取排行榜分类信息

请求地址：`/v1/kuwo/topCategory`

请求示例：`http://iecoxe.top:5000/v1/kuwo/topCategory`

| 参数 | 是否必须 | 接口说明             | 默认值 |
| ---- | -------- | -------------------- | ------ |
| from | ×        | from填 `pc` 或 `web` | `pc`   |

说明：`pc`返回的数据量少，但是默认`官方榜`提供前三首歌曲的信息

​			`web`返回的数据量多，但是所有榜单都不提供前三首歌曲的信息



## 获取歌单标签下的歌单信息

请求地址：`/v1/kuwo/playlist/tag`

请求示例：`http://iecoxe.top:5000/v1/kuwo/playlist/tag`

| 参数   | 是否必须 | 接口说明                                                  | 默认值 |
| ------ | -------- | --------------------------------------------------------- | ------ |
| id     | √        | 歌单标签 ID                                               | 146    |
| flag   | ×        | 标志参数 只能传入 `0/1`                                   | 0      |
| order  | ×        | flag为 `1` 时，只能传入  `hot/new` ，反之不需要传入此参数 | hot    |
| limit  | ×        | 返回歌曲数量                                              | 30     |
| offset | ×        | 数据偏移页数                                              | 1      |



## 获取歌单标签分类

请求地址：`/v1/kuwo/playlist/tagCategory`

请求示例：`http://iecoxe.top:5000/v1/kuwo/playlist/tagCategory`

| 参数 | 是否必须 | 接口说明 | 默认值 |
| ---- | -------- | -------- | ------ |
| 无   |          |          |        |



## 获取歌单歌曲列表

请求地址：`/v1/kuwo/playlist/info`

请求示例：`http://iecoxe.top:5000/v1/kuwo/playlist/info?pid=3127794871`

| 参数   | 是否必须 | 接口说明     | 默认值     |
| ------ | -------- | ------------ | ---------- |
| pid    | √        | 歌单 ID      | 3127794871 |
| limit  | ×        | 返回歌曲数量 | 30         |
| offset | ×        | 数据偏移页数 | 1          |

